#define MODULE
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/rtf.h>
#include <asm/rt_irq.h>
#include <asm/rt_time.h>
#include <linux/rt_sched.h>
#include <asm/io.h>
#include <linux/cons.h>
#include "common.h"

#define TIMEOUT 100000
#define SKIP 1000

#define NTASKS 2
RT_TASK mytask[NTASKS];
RTIME min_diff;
RTIME max_diff;
int PERIOD[NTASKS];
RTIME expected[NTASKS];
struct sample samp;
int skip;

void fun(int t) {

	RTIME diff;

/*	rt_use_fp(1);*/
	r_cli();

	while (1) {
		min_diff = 1000000000;
		max_diff = -1000000000;
		for (skip = 0; skip < SKIP; skip++) {
			expected[t] += PERIOD[t];
			rt_task_wait();

			diff = rt_get_time() - expected[t];
			if (diff < min_diff) {
				min_diff = diff;
			}
			if (diff > max_diff) {
				max_diff = diff;
			}

		}
		samp.min = min_diff;
		samp.max = max_diff;
		rtf_put(DEBUG_FIFO, &t, sizeof(t));
		rtf_put(DEBUG_FIFO, &samp, sizeof(samp));
	}
}


int init_module(void)
{
	RTIME now = rt_get_time();
	int x;
	rtf_create(DEBUG_FIFO, 4000);
	for (x=0; x<NTASKS; x++){
	    rt_task_init(&(mytask[x]), fun, x, 3000, x+1);
	    expected[x] = now + 2000;
	    PERIOD[x]  = 1000*(x+1);
	    rt_task_make_periodic(&(mytask[x]), expected[x], PERIOD[x]);
	}
	return 0;
}


void cleanup_module(void)
{
	int x;
	for (x=0; x<NTASKS; x++){
		rt_task_delete(&(mytask[x]));
	}
	
	rtf_destroy(DEBUG_FIFO);

}




